#!/bin/bash
#
# Transcode directory to ogg

set -e

DIRNAME="$1"
VGMSTREAM="/home/agashlin/Desktop/vgmstream/test/test"

if ! [ -d "$DIRNAME" ] ; then
    echo "missing dir"
    exit
fi

DIRNAMEBASE="$(basename "$DIRNAME")"

mkdir "$DIRNAMEBASE"
cd "$DIRNAMEBASE"
ls "$DIRNAME" | while read FILENAME ; do
    FILENAMENOEXT="$(echo "$FILENAME" | sed -e "s/[.][^.]*\$//")"
    FILENAMEEXT="$(echo "$FILENAME" | sed -e "s/^.*[.]\([^.]*\)\$/\\1/")"

    case "$FILENAMEEXT" in
    wav | flac)
        oggenc -q 5 -o "$FILENAMENOEXT.ogg" "$DIRNAME/$FILENAME"
        ;;
    ogg)
        cp "$DIRNAME/$FILENAME" "$FILENAMENOEXT.ogg"
        ;;
    *)
        if [ -x "$VGMSTREAM" ] ; then
            if "$VGMSTREAM" -m "$DIRNAME/$FILENAME" ; then
                "$VGMSTREAM" -p "$DIRNAME/$FILENAME" | oggenc -q 5 -o "$FILENAMENOEXT.ogg" -
            else
                echo "skipping $FILENAME"
            fi
        else
            echo "missing vgmstream for $FILENAME"
        fi
        ;;
    esac
done
cd ..
